
public class BenutzerVerwalterA {

  private int maxBenutzerzahl = 100;
  private int aktBenutzerzahl = 0;
  private int maxPIN = 0;
  private Benutzer[] benutzerDaten;

  public BenutzerVerwalterA() {
    benutzerDaten = new Benutzer[maxBenutzerzahl];
    for (int i = 0; i < benutzerDaten.length; i++) {
      benutzerDaten[i] = null;
    }
  }

  public String gibVersion() {
    return "A: ARRAY, Sortieren  Kriterium Name/ Verbrauch/ PIN";
  }

  private String erzeugePIN() {
    int intervall = 15000/maxBenutzerzahl;
    int zufallszahl = (int) (Math.random()*intervall) + 1;
    maxPIN = maxPIN + zufallszahl;   
    String pin = "" + maxPIN;
    if (pin.length() == 1) {
      pin = "000"+pin;
    }
    if (pin.length() == 2) {
      pin = "00"+pin;
    }
    if (pin.length() == 3) {
      pin = "0"+pin;
    }
    return pin;
  }

  public void neuerBenutzer(String pName) {
    boolean vorhanden;
    String pin;
    Benutzer b = null;
    do {
      pin = erzeugePIN();
      if (aktBenutzerzahl > 0) {
        b = lineareSuchePIN(pin); 
      }
      if (b == null) {
        vorhanden = false; 
      } else {
        vorhanden = true;
      }
    } while (vorhanden); 
    if (!vorhanden) {
      eintragen(pName,pin);
      //System.out.println(pName+" "+pin+" anzahl: "+aktBenutzerzahl);
    }
  }

  public void beispielBelegung() {
    for (int i = 0; i < 25; i++) {
      neuerBenutzer("A"+i);

    }
    neuerBenutzer("Test");
  }

  private int pinNr(String pPIN) {
    return Integer.parseInt(pPIN);
  }

  private void eintragen(String pName, String pPIN) {
    Benutzer neu = new Benutzer(pName,pPIN);
    int anzahl = (int) (Math.random()*1000);
    neu.erhoeheVerbrauch(anzahl);
    benutzerDaten[aktBenutzerzahl] = neu;  
    System.out.println((aktBenutzerzahl)+" "+benutzerDaten[aktBenutzerzahl].gibName()+" "+benutzerDaten[aktBenutzerzahl].gibPIN());
    aktBenutzerzahl++;
  }

  private Benutzer lineareSucheName(String pName) {
    boolean gefunden = false;
    int zaehler = 0;
    while (gefunden == false && zaehler < benutzerDaten.length) {
      if (benutzerDaten[zaehler] != null && benutzerDaten[zaehler].gibName().equals(pName)) {
        gefunden = true;
      } else {
        zaehler = zaehler + 1;
      }
    }
    if (zaehler < benutzerDaten.length) {
      return benutzerDaten[zaehler];
    } else {
      return null;
    }
  }

  private Benutzer lineareSuchePIN(String pPIN) {
    boolean gefunden = false;
    int zaehler = 0;
    while (gefunden == false && zaehler < benutzerDaten.length) {
      if (benutzerDaten[zaehler] != null && benutzerDaten[zaehler].gibPIN().equals(pPIN)) {
        gefunden = true;
      } else {
        zaehler = zaehler + 1;
      }
    }
    if (zaehler < benutzerDaten.length) {
      return benutzerDaten[zaehler];
    } else {
      return null;
    }
  }

  private Benutzer binaereItSuchePIN(String pSuchPIN) {
    int links, rechts, mitte, index;
    links = 0;
    rechts = aktBenutzerzahl;
    index = -1;
    while (links <= rechts && index < 0) {
      mitte = (rechts + links)/2; 
      if (benutzerDaten[mitte].gibPIN().equals(pSuchPIN)) {
        index = mitte;
      }
      if (benutzerDaten[mitte].gibPIN().compareTo(pSuchPIN) < 0) {
        links = mitte + 1;
      }
      if (benutzerDaten[mitte].gibPIN().compareTo(pSuchPIN) > 0) {
        rechts = mitte - 1;
      }
      System.out.println("links "+links+" rechts "+rechts+" mitte "+mitte);
    }
    if (index >= 0 && index < benutzerDaten.length) {
      return benutzerDaten[index];
    } else {
      return null;
    }
  }

  private Benutzer binaereRekSuchePIN(String pSuchPIN, int pLinks, int pRechts) {
    if ((pLinks < 0) || (pRechts > aktBenutzerzahl) || (pLinks > pRechts) ) {
      return null;
    } else {
      int mitte = (pLinks + pRechts)/2;
      System.out.println(mitte+": "+pLinks+" | "+mitte+" | "+pRechts+"- "+benutzerDaten[mitte].gibPIN());
      if (benutzerDaten[mitte].gibPIN().equals(pSuchPIN)) {
        System.out.println(benutzerDaten[mitte].gibName());
        return benutzerDaten[mitte];
      } else if (benutzerDaten[mitte].gibPIN().compareTo(pSuchPIN) > 0) {
        return binaereRekSuchePIN(pSuchPIN, pLinks, mitte-1);
      } else {
        return binaereRekSuchePIN(pSuchPIN, mitte+1, pRechts);
      }
    }
  }

  public Benutzer suchePIN(String pSuchPIN) {
    //return binaereItSuchePIN(pSuchPIN);
    return binaereRekSuchePIN(pSuchPIN, 0, aktBenutzerzahl-1);
  }

  public Benutzer sucheBenutzerName(String pName) {
    return lineareSucheName(pName);
  }

  public String erstelleAusgabe() {
    String ausgabe = "";
    for (int i = 0; i < aktBenutzerzahl; i++) {
      String zeile;
      if (i < 9) {
        zeile = "  "+(i+1)+" ";
      } else {
        zeile = ""+(i+1)+" ";
      }
      zeile = zeile + "  "+ benutzerDaten[i].gibName();
      zeile = zeile + "\t "+ benutzerDaten[i].gibAnzahl();
      ausgabe = ausgabe + zeile + "\n";
    }
    return ausgabe;
  }

  public void sortiereVerbrauch() {
    // Straight Selection
    for (int i = 0; i < aktBenutzerzahl; i++) {  
      int max = i;
      for (int j = i+1; j < aktBenutzerzahl; j++){     
        if (benutzerDaten[j].gibAnzahl() > benutzerDaten[max].gibAnzahl()) {
          max = j;
        }
        Benutzer temp = benutzerDaten[i];
        benutzerDaten[i] = benutzerDaten[max];
        benutzerDaten[max] = temp;
      }
    }
  }

  public void sortiereNamen() {
    // Straight Insertion
    for (int i = 1; i < aktBenutzerzahl; i++) {
      Benutzer aktuell = benutzerDaten[i];
      int j = i;
      while (j > 0 && benutzerDaten[j-1].gibName().compareTo(aktuell.gibName()) > 0) {
        benutzerDaten[j] = benutzerDaten[j - 1];
        j--;
      }
      benutzerDaten[j] = aktuell;
    }
  }

  public void sortierePIN() {
    // Quicksort
    int n = aktBenutzerzahl;
    quicksort(0, n-1);
  }

  private void quicksort (int lo, int hi) {
    int i = lo, j = hi;

    // Vergleichselement pivot (PIN)
    String pivot = benutzerDaten[lo+(hi-lo)/2].gibPIN();
    //  Aufteilung
    while (i <= j) {    
      while (benutzerDaten[i].gibPIN().compareTo(pivot) < 0) { i++; } 
      while (benutzerDaten[j].gibPIN().compareTo(pivot) > 0) { j--; }
      if (i <= j) {
        tausche(i, j);
        i++; j--;
      }
    }
    // Rekursion
    if (lo < j) { quicksort(lo, j); }
    if (i < hi) { quicksort(i, hi); }
  }

  private void tausche(int i, int j) {
    Benutzer b = benutzerDaten[i];
    benutzerDaten[i] = benutzerDaten[j];
    benutzerDaten[j] = b;
  }

}

